/***********************************************************
	Fraktalu ScreenSaver'is

	 2007 A-E Software 
	Arvydas Burdulis
	http://ae.dar.lt  aab@auto.lt

	Screensaveris, piesiantis fraktalus

	Pradetas:
	    2007-12-01
	Paskutini karta redaguota:
	    2007-12-11
************************************************************/


#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <scrnsave.h>
#include <GL/gl.h>
#include <GL/glu.h>


static HDC hDC;
static HGLRC hRC;
bool bTumble = true;

#include "kodas\zinutes.hpp"
#include "kodas\tekstas.hpp"
#include "kodas\laikas.hpp"
#include "kodas\geom_obj.hpp"
#include "kodas\Piesimas.hpp"



void InitGL(HWND hWnd, HDC & hDC, HGLRC & hRC);
void CloseGL(HWND hWnd, HDC hDC, HGLRC hRC);



LRESULT WINAPI ScreenSaverProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
		//Sukuriamas langas
		case WM_CREATE: 
			//Gauti monitoriaus nustatymus
			piesti.x = GetSystemMetrics(SM_CXSCREEN);	
			piesti.y = GetSystemMetrics(SM_CYSCREEN);
			if((float)piesti.x / (float)piesti.y > 1.34){
				piesti.ox = (int)((float)piesti.x / (float)piesti.y * 600);
				piesti.oy = 600;
				//Klaida("Screenas: %d %d", piesti.ox, piesti.oy);
			}
			if((float)piesti.x / (float)piesti.y < 1.33){
				piesti.oy = (int)((float)piesti.y / (float)piesti.x * 800);
				piesti.ox = 800;
			}
			//if(piesti
			//Inicializuoti OpenGL
			InitGL(hWnd, hDC, hRC);
			piesti.Init();
			laikas.Pradeti();
			laikas.Paleisti();
			tekstas.Sukurti();
			glCullFace(GL_NONE);
    		return 0;
    	//Naikinamas langas
		case WM_DESTROY:
			tekstas.Naikinti();
			CloseGL(hWnd, hDC, hRC);
			return 0;
		//Piesiama scena
		case WM_PAINT:
			laikas.Gauti();
			piesti.Atnaujinti();
			piesti.Piesti();
			SwapBuffers(hDC);
			return true;				
	}

	return DefScreenSaverProc(hWnd, message, wParam, lParam);
}


//Nustatymu dialogas
BOOL WINAPI
ScreenSaverConfigureDialog(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message == WM_INITDIALOG)
		Klaida("Siam screensaver'iui nera nustatymu");
	return true; 
}


BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
	return true;
}


// Initialize OpenGL
void InitGL(HWND hWnd, HDC & hDC, HGLRC & hRC)
{
	static	PIXELFORMATDESCRIPTOR pfd=				//pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				//Size Of This Pixel Format Descriptor
		1,											//Version Number
		PFD_DRAW_TO_WINDOW |						//Format Must Support Window
		PFD_SUPPORT_OPENGL |						//Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							//Must Support Double Buffering
		PFD_TYPE_RGBA,								//Request An RGBA Format
		32,											//Bits per pixel
		0, 0, 0, 0, 0, 0,							//Color Bits Ignored
		0,											//No Alpha Buffer
		0,											//Shift Bit Ignored
		0,											//No Accumulation Buffer
		0, 0, 0, 0,									//Accumulation Bits Ignored
		24,											//Z-Buferio gylis 
		0,											//No Stencil Buffer
		0,											//No Auxiliary Buffer
		PFD_MAIN_PLANE,								//Main Drawing Layer
		0,											//Reserved
		0, 0, 0										//Layer Masks Ignored
	};

	hDC = GetDC(hWnd);
	int pForm = ChoosePixelFormat(hDC, &pfd);  
	SetPixelFormat(hDC, pForm, &pfd);
	hRC = wglCreateContext(hDC);
	wglMakeCurrent(hDC, hRC);
	
	//Nustatomi OpenGL parametrai
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glCullFace(GL_BACK);
	
	glViewport(0, 0, piesti.x, piesti.y);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


// Shut down OpenGL
void CloseGL(HWND hWnd, HDC hDC, HGLRC hRC)
{
	wglMakeCurrent(NULL, NULL);
	wglDeleteContext(hRC);
	ReleaseDC(hWnd, hDC);
}
