KTekstas::KTekstas(): eilSk(0), sukurtas(false), uzkrautas(false)
{
}

KTekstas::~KTekstas()
{
}

bool KTekstas::Sukurti()
{
	HFONT	font;										// Windows Font ID
	HFONT	oldfont;									// Used For Good House Keeping

	fontDispList = glGenLists(223);						// Storage For Characters

	font = CreateFont(	-16,							// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_NORMAL,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						BALTIC_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						"Tunga");					    // Font Name

	oldfont = (HFONT)SelectObject(hDC, font);           // Selects The Font We Want
	wglUseFontBitmaps(hDC, 32, 223, fontDispList);		// Builds Characters Starting At Character 32
	SelectObject(hDC, oldfont);							// Selects The Font We Want
	DeleteObject(font);	
	sukurtas = true;
	return true;
}

/*
void KTekstas::Uzkrauti(const char *pavad)
{
    char eilut[512];
    ifstream fd(pavad);
    if(!fd.fail())
		while(fd.good()){
			if (eilSk >= EIL_SK){
				Klaida("Pasiektas teksto eiluciu limitas");
				break;
			}
        	fd.get(eilut, 512);
        	fd.ignore();
        	if(strlen(eilut) >= EIL_ILG){
				Klaida("Eilute \"%s\" ilgesne nei %d", eilut, EIL_ILG);
				continue;
			}
        	if(strlen(eilut) < 1){
				#ifdef DEBUG
				cout<<" tekstas->Uzkrauti:tuscia eilute ";
				#endif
        		continue;
			}
        	else{
        		strcpy(eil[eilSk], eilut);
        		eilSk++;
			}
    	}
    else
        Klaida("Nerastas failas %s", pavad);
    fd.close();
    uzkrautas = true;
}
*/

void KTekstas::Piesti(const char *eil)
{
	if(eil == NULL)
		return;
	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(fontDispList - 32);						// Sets The Base Character to 32
	glCallLists(strlen(eil), GL_UNSIGNED_BYTE, eil);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

void KTekstas::PiestiNeform(const char *fmt, ...)
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
    vsprintf(text, fmt, ap);                            // And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(fontDispList - 32);						// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

void KTekstas::Naikinti()
{
	if(sukurtas)
    	glDeleteLists(fontDispList, 223);
    sukurtas = false;
}


//------------------------------------------------------------------------------
/*
KTekstF::KTekstF(): eilSk(0), uzkrautas(false)
{
	for(int i = 0; i < EIL_SK; i++)
		eil[i] = NULL;
}

KTekstF::~KTekstF()
{
}

void KTekstF::Uzkrauti(const char *pav)
{
	if(uzkrautas){
		Klaida("Failas '%s' uzkraunamas antra karta", pav);
		Naikinti();
	}
		
	#ifdef DEBUG
		cout<<"\n  failas: "<<pav;
	#endif
		
	char eilut[256];
    ifstream fd(pav);
    if(!fd.fail())
		while(fd.good()){
			if (eilSk >= EIL_SK){
				Klaida("Pasiektas teksto eiluciu limitas");
				break;
			}
        	fd.get(eilut, 255);
        	fd.ignore();
        	if(strlen(eilut) >= 255){
				Klaida("Eilute \"%s\" ilgesne nei 256", eilut);
				continue;
			}
        	if(strlen(eilut) < 1){
				#ifdef DEBUG
					cout<<" tekstas->Uzkrauti:tuscia eilute ";
				#endif
        		continue;
			}
        	else{
				try{ eil[eilSk] = new char[strlen(eilut) + 1]; }
				catch(...){ Klaida("Klaida skaitant fila \"%s\": neisskirta atmintis teksto eilutei", pav); }
        		strcpy(eil[eilSk], eilut);
        		eilSk++;
			}
    	}
    else
        Klaida("Nerastas failas %s", pav);
    fd.close();
	
	uzkrautas = true;
}

void KTekstF::Piesti(GLfloat x, GLfloat y)
{
	if(!uzkrautas)
		return;
	
	for(int i = 0; i < eilSk; i++){
		glRasterPos2f(x, y - (i * 20.0));
		tekstas.Piesti(eil[i]);
	}
}

void KTekstF::Naikinti()
{
	if(!uzkrautas)
		return;
	for(int i = 0; i < eilSk; i++)
		delete[] eil[i];
	eilSk = 0;
	uzkrautas = false;
}
*/
